<?php
namespace PME\Controllers\Servico;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class ConsPorServicoController extends \PME\Services\TeknisaCrud {
  protected $crudService;
	protected $parameterBag;
	protected $dataSourceName;
	protected $connection;

    public function __construct($crudService, $parameterBag, $connection) {
        parent::__construct($crudService, $parameterBag);
        $this->connection = $connection;
	}

  public function saveConsPadr(DTO\Request $request, DTO\Response $response) {
    try {
        $this->connection->beginTransaction();
        $rows = (array) $request->getRow();

        $dataSourceName = 'consServPme';
        $this->callSave($dataSourceName, $rows);
        $this->connection->commit();
        $response->addDataSet(new DataSet("columnsToReturn", $this->crudService->getColumnsToReturn()));
    } catch (\Exception $e) {
      $this->connection->rollback();
      $response->setError(new Error($e->getMessage(), 500));
    }
  }

  public function saveSemCons(DTO\Request $request, DTO\Response $response) {
    try {
        $this->connection->beginTransaction();
        $rows = (array) $request->getRow();
        $rowsToSave = [];

        foreach($rows as $row) {
          if ($row['PERCAPITA'] == 'S' && $row['FIXO'] == 'S') $row['IDTPCONSPME'] = 'A';
          else if ($row['PERCAPITA'] == 'S') $row['IDTPCONSPME'] = 'P';
          else $row['IDTPCONSPME'] = 'F';
          
          array_push($rowsToSave, $row);
        }
        $this->deleteConsServ($rowsToSave);

        $dataSourceName = 'diaSemConsPme';
        $this->callSave($dataSourceName, $rowsToSave);
        $this->connection->commit();
        $response->addDataSet(new DataSet("columnsToReturn", $this->crudService->getColumnsToReturn()));
    } catch (\Exception $e) {
      $this->connection->rollback();
      $response->setError(new Error($e->getMessage(), 500));
    }
  }

  private function deleteConsServ($rows) {
    foreach($rows as $row){
      if ($row['IDTPCONSPME'] == 'A') $tipo = "'P','F'";
      else if ($row['IDTPCONSPME'] == 'F') $tipo = "'F'";
      else $tipo = "'P'";
      
      $query = "DELETE CONSSERVPME WHERE CDFILCENTPME = :CDFILCENTPME AND CDSERVFILI = :CDSERVFILI AND CDFILIAL =:CDFILIAL 
                      AND DTCONSERVPME = :DTCONSERVPME AND IDQTDECONPME IN ($tipo)";

      $params = array(
        'CDFILCENTPME'=> $row['CDFILCENTPME'],
        'CDSERVFILI'  => $row['CDSERVFILI'],
        'CDFILIAL'    => $row['CDFILIAL'],
        'DTCONSERVPME' => $row['DTSEMCONSPME'],
      );

      $this->connection->prepare($query)->execute($params);
    }        
  }

  private function callSave($dataSourceName, $rowsToSave){
    $dataSet = new DataSet($dataSourceName, $rowsToSave);
    $request = new DTO\Request\DataSet($dataSet, "", "", "");  
    $rowsToSave = $this->crudService->getRowsToSave($request, $dataSourceName);
    $this->crudService->save($dataSourceName, $rowsToSave);
  }
}